package guard.api.sensitive.ui.sapiguard.hookedapis;

import java.util.ArrayList;
import java.util.List;

import guard.api.sensitive.ui.sapiguard.XHook;
import guard.api.sensitive.ui.sapiguard.utils.PrivacyManager;
import guard.api.sensitive.ui.sapiguard.utils.XParam;

public class XUsbDevice extends XHook {
	private Methods mMethod;

	private XUsbDevice(Methods method, String restrictionName) {
		super(restrictionName, method.name(), "USB." + method.name());
		mMethod = method;
	}

	public String getClassName() {
		return "android.hardware.usb.UsbDevice";
	}

	// public static int getDeviceId(String name)
	// public int getDeviceId()
	// public String getDeviceName()
	// public static String getDeviceName(int id)
	// public String getSerialNumber()
	// http://developer.android.com/reference/android/hardware/usb/UsbDevice.html

	private enum Methods {
		getDeviceId, getDeviceName, getSerialNumber
	};

	public static List<XHook> getInstances() {
		List<XHook> listHook = new ArrayList<XHook>();
		listHook.add(new XUsbDevice(Methods.getDeviceId, PrivacyManager.cIdentification));
		listHook.add(new XUsbDevice(Methods.getDeviceName, PrivacyManager.cIdentification));
		listHook.add(new XUsbDevice(Methods.getSerialNumber, PrivacyManager.cIdentification));
		return listHook;
	}

	@Override
	protected void before(XParam param) throws Throwable {
		// Do nothing
	}

	@Override
	protected void after(XParam param) throws Throwable {

	}
}
